#/bin/bash

restore_all_f81504() {
	insmod f81504_series.ko 2> /dev/null
	modprobe f81504_series 2> /dev/null
	
	DEV=`ls /sys/bus/pci/devices/ | grep ":"`

	for i in $DEV
	do
		echo $i > "/sys/bus/pci/drivers/serial/bind" 2> /dev/null
		
		if [ $? = "0" ]; then
			echo "Restore device to default driver: " $i
		fi
	done
}

remove_all_f81504() {
	rmmod f81504_series 2> /dev/null
	
	DEV=`ls /sys/bus/pci/drivers/serial | grep ":"`

	for i in $DEV
	do
		VENDOR=`cat /sys/bus/pci/drivers/serial/$i/vendor`
		#echo $i, $VENDOR
		
		if [ $VENDOR = "0x1c29" ]; then
			echo "Remove device: " $i
			echo $i > /sys/bus/pci/drivers/serial/unbind
		fi

	done
}

set_serial_io() {
	#setserial $1 uart none port $2 
	IO_ADDR=`cat /sys/class/tty/$1/port`
	
	echo $1, $2, $IO_ADDR
	
	if [ "$2" == "$IO_ADDR" ]; then
		echo $1 skip change
	else
		echo $1 change to IO $2
		setserial /dev/$1 port $2
	fi
}

customer_fix_com(){
	# 客戶請自行修改對應的 ttySx <=> IO address
	# 請記得 io address 都是大寫
	# 也請記得要安裝 setserial

	:;

	set_serial_io "ttyS1" 0x3000
	set_serial_io "ttyS2" 0x3008
	set_serial_io "ttyS3" 0x3010
	set_serial_io "ttyS4" 0x3018
	set_serial_io "ttyS5" 0x3020
	set_serial_io "ttyS6" 0x3028
	set_serial_io "ttyS7" 0x3030
	set_serial_io "ttyS8" 0x3038
	
	set_serial_io "ttyS9" 0x4000
	set_serial_io "ttyS10" 0x4008
	set_serial_io "ttyS11" 0x4010
	set_serial_io "ttyS12" 0x4018
	set_serial_io "ttyS13" 0x4020
	set_serial_io "ttyS14" 0x4028
	set_serial_io "ttyS15" 0x4030
	set_serial_io "ttyS16" 0x4038
}

#script start
remove_all_f81504
customer_fix_com
restore_all_f81504
